#include "pdfevol.h"
#include "settings.h"
#include "mellinint.h"
#include "mesq.h"
#include "parton.h"

using namespace parton;

//Save the evolved PDFs into the fx1 and fx2 arrays --> signed version
/*
void pdfevol::storemoments(int i, int sign, complex <double> fx[11], complex <double> ft)
{
  int nf = 2*MAXNF+1;
  if (sign == mesq::positive)
    {
      copy(fx, fx+nf, fx1+i*nf);
      copy(fx, fx+nf, fx2+i*nf);
      fotx1[i] = ft;
      fotx2[i] = ft;
    }
  else
    {
      //return;
      int negidx = mellinint::mdim*11;
      copy(fx, fx+nf, fx1+negidx+i*nf);
      copy(fx, fx+nf, fx2+negidx+i*nf);
      fotx1[mellinint::mdim+i] = ft;
      fotx2[mellinint::mdim+i] = ft;
    }      
}
*/
/*
void pdfevol::storemoments_b(int i, int sign, complex <double> fx[11])
{
  int nf = 2*MAXNF+1;
  if (sign == mesq::positive)
    {
      fx1[i*nf+b ] = fx[b];
      fx1[i*nf+bb] = fx[bb ];
      fx2[i*nf+b ] = fx[b ];
      fx2[i*nf+bb] = fx[bb];
    }
  else
    {
      int negidx = mellinint::mdim*11;
      fx1[negidx+i*nf+bb] = fx[bb];
      fx1[negidx+i*nf+b ] = fx[b ];
      fx2[negidx+i*nf+bb] = fx[bb];
      fx2[negidx+i*nf+b ] = fx[b ];
    }      
}
*/
/*
void pdfevol::storemoments_c(int i, int sign, complex <double> fx[11])
{
  int nf = 2*MAXNF+1;
  if (sign == mesq::positive)
    {
      fx1[i*nf+c ] = fx[c];
      fx1[i*nf+cb] = fx[cb ];
      fx2[i*nf+c ] = fx[c ];
      fx2[i*nf+cb] = fx[cb];
    }
  else
    {
      int negidx = mellinint::mdim*11;
      fx1[negidx+i*nf+cb] = fx[cb];
      fx1[negidx+i*nf+c ] = fx[c ];
      fx2[negidx+i*nf+cb] = fx[cb];
      fx2[negidx+i*nf+c ] = fx[c ];
    }      
}
*/

void pdfevol::storemoments_1(int i, int sign, complex <double> fx[11], complex <double> ft)
{
  int nf = 2*MAXNF+1;
  if (sign == mesq::positive)
    {
      copy(fx, fx+nf, fx1+i*nf);
      fotx1[i] = ft;
    }
  else
    {
      int negidx = mellinint::mdim*11;
      copy(fx, fx+nf, fx1+negidx+i*nf);
      fotx1[mellinint::mdim+i] = ft;
    }
}  
void pdfevol::storemoments_2(int i, int sign, complex <double> fx[11], complex <double> ft)
{
  int nf = 2*MAXNF+1;
  if (sign == mesq::positive)
    {
      copy(fx, fx+nf, fx2+i*nf);
      fotx2[i] = ft;
    }
  else
    {
      int negidx = mellinint::mdim*11;
      copy(fx, fx+nf, fx2+negidx+i*nf);
      fotx2[mellinint::mdim+i] = ft;
    }
}  

void pdfevol::storemoments_1_b(int i, int sign, complex <double> fx[11])
{
  int nf = 2*MAXNF+1;
  if (sign == mesq::positive)
    {
      fx1[i*nf+bb] = fx[bb];
      fx1[i*nf+b ] = fx[b ];
    }
  else
    {
      int negidx = mellinint::mdim*11;
      fx1[negidx+i*nf+bb] = fx[bb];
      fx1[negidx+i*nf+b ] = fx[b ];
    }
}  
void pdfevol::storemoments_2_b(int i, int sign, complex <double> fx[11])
{
  int nf = 2*MAXNF+1;
  if (sign == mesq::positive)
    {
      fx2[i*nf+bb] = fx[bb];
      fx2[i*nf+b ] = fx[b ];
    }
  else
    {
      int negidx = mellinint::mdim*11;
      fx2[negidx+i*nf+bb] = fx[bb];
      fx2[negidx+i*nf+b ] = fx[b ];
    }
}  

void pdfevol::storemoments_1_c(int i, int sign, complex <double> fx[11])
{
  int nf = 2*MAXNF+1;
  if (sign == mesq::positive)
    {
      fx1[i*nf+cb] = fx[cb];
      fx1[i*nf+c ] = fx[c ];
    }
  else
    {
      int negidx = mellinint::mdim*11;
      fx1[negidx+i*nf+cb] = fx[cb];
      fx1[negidx+i*nf+c ] = fx[c ];
    }
}  
void pdfevol::storemoments_2_c(int i, int sign, complex <double> fx[11])
{
  int nf = 2*MAXNF+1;
  //buggy version
  if (opts.hfmode == 2)
    if (sign == mesq::positive)
      {
	fx2[i*nf+bb] = fx[bb];
	fx2[i*nf+b ] = fx[b ];
      }
    else
      {
	int negidx = mellinint::mdim*11;
	fx2[negidx+i*nf+bb] = fx[bb];
	fx2[negidx+i*nf+b ] = fx[b ];
      }
  //bug fix
  else //if (opts.hfmode == 3)
    if (sign == mesq::positive)
      {
	fx2[i*nf+cb] = fx[cb];
	fx2[i*nf+c ] = fx[c ];
      }
    else
      {
	int negidx = mellinint::mdim*11;
	fx2[negidx+i*nf+cb] = fx[c ];
	fx2[negidx+i*nf+c ] = fx[cb];
      }
}  

/*
void pdfevol::storemoments(int i, complex <double> fx[11], complex <double> ft)
{
  //Save the evolved PDFs into the fx1 and fx2 arrays
  int negidx = mellinint::mdim*11;
  int nf = 2*MAXNF+1;

  //beam 1 positive
  copy(fx, fx+nf, fx1+i*nf);
  fotx1[i] = ft;
  
  //beam 2 positive
  copy(fx, fx+nf, fx2+i*nf); 
  fotx2[i] = ft;

  //beam 1 negative (never used)
  //fx1[negidx+i*nf+g ] = conj(fx[g ]);
  //fotx1[mellinint::mdim+i] = conj(ft);
  //fx1[negidx+i*nf+bb] = conj(fx[bb]);
  //fx1[negidx+i*nf+cb] = conj(fx[cb]);
  //fx1[negidx+i*nf+sb] = conj(fx[sb]);
  //fx1[negidx+i*nf+db] = conj(fx[db]);
  //fx1[negidx+i*nf+ub] = conj(fx[ub]);
  //fx1[negidx+i*nf+u ] = conj(fx[u ]);
  //fx1[negidx+i*nf+d ] = conj(fx[d ]);
  //fx1[negidx+i*nf+s ] = conj(fx[s ]);
  //fx1[negidx+i*nf+c ] = conj(fx[c ]);
  //fx1[negidx+i*nf+b ] = conj(fx[b ]);

  //beam 2 negative
  fx2[negidx+i*nf+g ] = conj(fx[g ]);
  fotx2[mellinint::mdim+i] = conj(ft);
  fx2[negidx+i*nf+bb] = conj(fx[bb]);
  fx2[negidx+i*nf+cb] = conj(fx[cb]);
  fx2[negidx+i*nf+sb] = conj(fx[sb]);
  fx2[negidx+i*nf+db] = conj(fx[db]);
  fx2[negidx+i*nf+ub] = conj(fx[ub]);
  fx2[negidx+i*nf+u ] = conj(fx[u ]);
  fx2[negidx+i*nf+d ] = conj(fx[d ]);
  fx2[negidx+i*nf+s ] = conj(fx[s ]);
  fx2[negidx+i*nf+c ] = conj(fx[c ]);
  fx2[negidx+i*nf+b ] = conj(fx[b ]);
}  
*/

void pdfevol::storemoments_1(int i, complex <double> fx[11], complex <double> ft)
{
  //Save the evolved PDFs into the fx1 and fx2 arrays
  int negidx = mellinint::mdim*11;
  int nf = 2*MAXNF+1;

  //beam 1 positive
  copy(fx, fx+nf, fx1+i*nf);
  fotx1[i] = ft;

  //beam 1 negative (never used)
  //fx1[negidx+i*nf+g ] = conj(fx[g ]);
  //fotx1[mellinint::mdim+i] = conj(ft);
  //fx1[negidx+i*nf+bb] = conj(fx[bb]);
  //fx1[negidx+i*nf+cb] = conj(fx[cb]);
  //fx1[negidx+i*nf+sb] = conj(fx[sb]);
  //fx1[negidx+i*nf+db] = conj(fx[db]);
  //fx1[negidx+i*nf+ub] = conj(fx[ub]);
  //fx1[negidx+i*nf+u ] = conj(fx[u ]);
  //fx1[negidx+i*nf+d ] = conj(fx[d ]);
  //fx1[negidx+i*nf+s ] = conj(fx[s ]);
  //fx1[negidx+i*nf+c ] = conj(fx[c ]);
  //fx1[negidx+i*nf+b ] = conj(fx[b ]);
}  

void pdfevol::storemoments_2(int i, complex <double> fx[11], complex <double> ft)
{
  //Save the evolved PDFs into the fx1 and fx2 arrays
  int negidx = mellinint::mdim*11;
  int nf = 2*MAXNF+1;

  //beam 2 positive
  copy(fx, fx+nf, fx2+i*nf);
  fotx2[i] = ft;

  //beam 2 negative
  fx2[negidx+i*nf+g ] = conj(fx[g ]);
  fotx2[mellinint::mdim+i] = conj(ft);
  fx2[negidx+i*nf+bb] = conj(fx[bb]);
  fx2[negidx+i*nf+cb] = conj(fx[cb]);
  fx2[negidx+i*nf+sb] = conj(fx[sb]);
  fx2[negidx+i*nf+db] = conj(fx[db]);
  fx2[negidx+i*nf+ub] = conj(fx[ub]);
  fx2[negidx+i*nf+u ] = conj(fx[u ]);
  fx2[negidx+i*nf+d ] = conj(fx[d ]);
  fx2[negidx+i*nf+s ] = conj(fx[s ]);
  fx2[negidx+i*nf+c ] = conj(fx[c ]);
  fx2[negidx+i*nf+b ] = conj(fx[b ]);
}  

void pdfevol::storemoments_fortran(int i, complex <double> fx[11])
{
  //Save the evolved PDFs into the fortran common block
  //beam 1
  creno_.cfx1_[i][-5+MAXNF] = fcx(fx[-5+MAXNF]);
  creno_.cfx1_[i][-4+MAXNF] = fcx(fx[-4+MAXNF]);
  creno_.cfx1_[i][-3+MAXNF] = fcx(fx[-3+MAXNF]);
  creno_.cfx1_[i][ 0+MAXNF] = fcx(fx[ 0+MAXNF]);
  creno_.cfx1_[i][ 3+MAXNF] = fcx(fx[ 3+MAXNF]);
  creno_.cfx1_[i][ 4+MAXNF] = fcx(fx[ 4+MAXNF]);
  creno_.cfx1_[i][ 5+MAXNF] = fcx(fx[ 5+MAXNF]);
  creno_.cfx1_[i][-2+MAXNF] = fcx(fx[-2+MAXNF]);
  creno_.cfx1_[i][-1+MAXNF] = fcx(fx[-1+MAXNF]);
  creno_.cfx1_[i][ 1+MAXNF] = fcx(fx[ 1+MAXNF]);
  creno_.cfx1_[i][ 2+MAXNF] = fcx(fx[ 2+MAXNF]);

  //beam 2 positive
  creno_.cfx2p_[i][-5+MAXNF] = fcx(fx[-5+MAXNF]);
  creno_.cfx2p_[i][-4+MAXNF] = fcx(fx[-4+MAXNF]);
  creno_.cfx2p_[i][-3+MAXNF] = fcx(fx[-3+MAXNF]);
  creno_.cfx2p_[i][ 0+MAXNF] = fcx(fx[ 0+MAXNF]);
  creno_.cfx2p_[i][ 3+MAXNF] = fcx(fx[ 3+MAXNF]);
  creno_.cfx2p_[i][ 4+MAXNF] = fcx(fx[ 4+MAXNF]);
  creno_.cfx2p_[i][ 5+MAXNF] = fcx(fx[ 5+MAXNF]);
  creno_.cfx2p_[i][-2+MAXNF] = fcx(fx[-2+MAXNF]);
  creno_.cfx2p_[i][-1+MAXNF] = fcx(fx[-1+MAXNF]);
  creno_.cfx2p_[i][ 1+MAXNF] = fcx(fx[ 1+MAXNF]);
  creno_.cfx2p_[i][ 2+MAXNF] = fcx(fx[ 2+MAXNF]);

  //beam 2 negative
  creno_.cfx2m_[i][-5+MAXNF] = fcx(conj(fx[-5+MAXNF]));
  creno_.cfx2m_[i][-4+MAXNF] = fcx(conj(fx[-4+MAXNF]));
  creno_.cfx2m_[i][-3+MAXNF] = fcx(conj(fx[-3+MAXNF]));
  creno_.cfx2m_[i][ 0+MAXNF] = fcx(conj(fx[ 0+MAXNF]));
  creno_.cfx2m_[i][ 3+MAXNF] = fcx(conj(fx[ 3+MAXNF]));
  creno_.cfx2m_[i][ 4+MAXNF] = fcx(conj(fx[ 4+MAXNF]));
  creno_.cfx2m_[i][ 5+MAXNF] = fcx(conj(fx[ 5+MAXNF]));
  creno_.cfx2m_[i][-2+MAXNF] = fcx(conj(fx[-2+MAXNF]));
  creno_.cfx2m_[i][-1+MAXNF] = fcx(conj(fx[-1+MAXNF]));
  creno_.cfx2m_[i][ 1+MAXNF] = fcx(conj(fx[ 1+MAXNF]));
  creno_.cfx2m_[i][ 2+MAXNF] = fcx(conj(fx[ 2+MAXNF]));
}
